<?php

	namespace osCommerce\OM\Core\Site\Admin\Module\Payment;

	use osCommerce\OM\Core\OSCOM;
	use osCommerce\OM\Core\Registry;

	$sIdealcheckoutPath = dirname(__FILE__);
	$sIdealcheckoutLibrary = '/idealcheckout/includes/library.php';

	while((strlen($sIdealcheckoutPath) > 3) && !is_file($sIdealcheckoutPath . $sIdealcheckoutLibrary))
	{
		$sIdealcheckoutPath = dirname($sIdealcheckoutPath);
	}

	if(is_file($sIdealcheckoutPath . $sIdealcheckoutLibrary))
	{
		require_once($sIdealcheckoutPath . $sIdealcheckoutLibrary);
	}
	else
	{
		die('Cannot find ' . $sIdealcheckoutLibrary);
	}

	class Idealcheckoutauthorizedtransfer extends \osCommerce\OM\Core\Site\Admin\PaymentModuleAbstract
	{
		protected $_title;
		protected $_description;

		protected $_author_name = 'iDEAL Checkout';
		protected $_author_www = 'https://www.ideal-checkout.nl';
		protected $_status = false;

		protected function initialize()
		{
			$this->_title = OSCOM::getDef('iDEAL Checkout - Eenmalige machtiging');
			$this->_description = OSCOM::getDef('Eenmalige machtiging betalingen verwerken via uw Payment Service Provider.');
			$this->_status = (defined('MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_STATUS') && (MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_STATUS == '1') ? true : false);
			$this->_sort_order = (defined('MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_SORT_ORDER') ? MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_SORT_ORDER : 0);
		}

		public function isInstalled()
		{
			return defined('MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_STATUS');
		}

		public function install()
		{
			parent::install();

			$data = array(
				array(
					'title' => 'Enable method',
					'key' => 'MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_STATUS',
					'value' => '-1',
					'description' => 'Do you want to accept Eenmalige machtiging payments?<br>',
					'group_id' => '6',
					'use_function' => 'osc_cfg_use_get_boolean_value',
					'set_function' => 'osc_cfg_set_boolean_value(array(1, -1))'
				),
				array(
					'title' => 'Sort order',
					'key' => 'MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_SORT_ORDER',
					'value' => '0',
					'description' => 'Sort order of display. Lowest is displayed first.',
					'group_id' => '6'
				)
			);

			OSCOM::callDB('Admin\InsertConfigurationParameters', $data, 'Site');
		}

		public function getKeys()
		{
			return array(
				'MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_STATUS',
				'MODULE_PAYMENT_IDEALCHECKOUTAUTHORIZEDTRANSFER_SORT_ORDER'
			);
		}
	}

?>