<?php

/**
 * osCommerce Online Merchant
 * 
 * @copyright Copyright (c) 2011 osCommerce; http://www.oscommerce.com
 * @license BSD License; http://www.oscommerce.com/bsdlicense.txt
 */

	namespace osCommerce\OM\Core\Site\Shop\Module\Payment;

	use osCommerce\OM\Core\HttpRequest;
	use osCommerce\OM\Core\Mail;
	use osCommerce\OM\Core\OSCOM;
	use osCommerce\OM\Core\Registry;
	use osCommerce\OM\Core\Site\Shop\Order;
	use osCommerce\OM\Core\Site\Shop\Shipping;


	$sIdealcheckoutPath = dirname(__FILE__);
	$sIdealcheckoutLibrary = '/idealcheckout/includes/library.php';

	while((strlen($sIdealcheckoutPath) > 3) && !is_file($sIdealcheckoutPath . $sIdealcheckoutLibrary))
	{
		$sIdealcheckoutPath = dirname($sIdealcheckoutPath);
	}

	if(is_file($sIdealcheckoutPath . $sIdealcheckoutLibrary))
	{
		require_once($sIdealcheckoutPath . $sIdealcheckoutLibrary);
	}
	else
	{
		die('Cannot find ' . $sIdealcheckoutLibrary);
	}

	class Idealcheckoutideal extends \osCommerce\OM\Core\Site\Shop\PaymentModuleAbstract
	{
		protected function initialize()
		{
			$this->_title = 'iDEAL';
			$this->_method_title = 'iDEAL';
			$this->_method_description = 'Betaal met iDEAL';
			$this->_status = (defined('MODULE_PAYMENT_IDEALCHECKOUTIDEAL_STATUS') && (MODULE_PAYMENT_IDEALCHECKOUTIDEAL_STATUS == '1') ? true : false);
			$this->_sort_order = (defined('MODULE_PAYMENT_IDEALCHECKOUTIDEAL_SORT_ORDER') ? MODULE_PAYMENT_IDEALCHECKOUTIDEAL_SORT_ORDER : null);
		}

		public function selection()
		{
			return array('id' => $this->_code, 'module' => $this->_method_title, 'description' => $this->_method_description);
		}

		public function process()
		{
			$OSCOM_ShoppingCart = Registry::get('ShoppingCart');
			$OSCOM_Currencies = Registry::get('Currencies');

			$_order_id = Order::insert();
			Order::process($_order_id, '102');

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$sStoreCode = idealcheckout_getStoreCode();
			$sGatewayCode = 'ideal';
			$sLanguageCode = 'nl'; // nl, de, en
			$sCountryCode = '';
			$sCurrencyCode = 'EUR'; // $sCurrencyCode = $OSCOM_Currencies->getCode();


			// Add transaction record to database
			$sOrderId = $_order_id;
			$sOrderCode = idealcheckout_getRandomCode(32);
			$aOrderParams = array();
			$sTransactionId = idealcheckout_getRandomCode(32);
			$sTransactionCode = idealcheckout_getRandomCode(32);
			$fTransactionAmount = round($OSCOM_ShoppingCart->getTotal(), 2);
			$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
			$sTransactionPaymentUrl = OSCOM::getLink(null, 'Checkout', null, 'SSL', true, false);
			$sTransactionSuccessUrl = OSCOM::getLink(null, 'Checkout', 'Success', 'SSL', true, false);
			$sTransactionPendingUrl = OSCOM::getLink(null, 'Checkout', null, 'SSL', true, false);
			$sTransactionFailureUrl = OSCOM::getLink(null, 'Checkout', 'Failure', 'SSL', true, false);


			// Insert into #_transactions
			$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

			idealcheckout_database_query($sql);

			// Redirect to checkout
			OSCOM::redirect(idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
		}
	}

?>